<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use FM\Service\Fm00003000ChecklistService;
use FM\Traits\TResponse;

class Fm00003000ChecklistController extends FMCrud
{

    use TResponse;
    protected $ChecklistService;

    public function __construct($crudService, $environment, Fm00003000ChecklistService $ChecklistService)
    {
        parent::__construct($crudService, $environment);
        $this->ChecklistService = $ChecklistService;
    }

    /* INICIO TAB DE CHECKLIST */
    public function getAtividadesChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->getAtividadesChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getDadosChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->getDadosChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->salvarChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->excluirChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getChecklist()
    {
        try {
            $data = $this->ChecklistService->getChecklist();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAtivo(Request $request)
    {
        try {
            $data = $this->ChecklistService->getDadosChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function getDadosChecklistEdicao(Request $request)
    {
        try {
            $data = $this->ChecklistService->getDadosChecklistEdicao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    /* FIM TAB DE CHECKLIST */
 
    /* INICIO TAB ITENS */
    public function getItensChecklist()
    {
        try {
            $data = $this->ChecklistService->getItensChecklist();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarItemChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->salvarItemChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inativarItem(Request $request)
    {
        try {
            $data = $this->ChecklistService->inativarItem($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirItens(Request $request)
    {
        try {
            $data = $this->ChecklistService->excluirItem($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCriteriosChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->getCriteriosChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarRelacaoItemChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->salvarRelacaoItemChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getTarefasChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->getTarefasChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirItemChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->excluirItemChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    /* FIM TAB ITENS */

    /* INICIO TAB ATIVIDADES E CRITÉRIOS */
    public function getAtividadesCriterios() 
    {
        try {
            $data = $this->ChecklistService->getAtividadesCriterios();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getAtividadesAtivas() 
    {
        try {
            $data = $this->ChecklistService->getAtividadesAtivas();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
        
    public function salvarAtividadeCriterio(Request $request) 
    {
        try {
            $data = $this->ChecklistService->salvarAtividadeCriterio($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function inativarAtividadesCriterios(Request $request)
    {
        try {
            $data = $this->ChecklistService->inativarAtividadesCriterios($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* FIM TAB ATIVIDADES E CRITÉRIOS */
    public function verificarNomeItens(Request $request)
    {
        try {
            $data = $this->ChecklistService->verificarNomeItens($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    /* INICIO TAB DE ESCOPOS */
    public function getEscoposServicos() 
    {
        try {
            $data = $this->ChecklistService->getEscoposServicos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function salvarEscopoServico(Request $request) 
    {
        try {
            $data = $this->ChecklistService->salvarEscopoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function excluirEscopos(Request $request)
    {
        try {
            $data = $this->ChecklistService->excluirEscopos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    /* FIM TAB DE ESCOPOS */
    public function edicaoChecklist(Request $request)
    {
        try {
            $data = $this->ChecklistService->edicaoChecklist($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
