<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO\Request;
use FM\Traits\TResponse;
use FM\Service\FmIntegracaoHcmService;

class FmIntegracaoHcmController
{
    protected $FmIntegracaoHcmService;

    use TResponse;

    public function __construct(FmIntegracaoHcmService $FmIntegracaoHcmService)
    {
        $this->FmIntegracaoHcmService = $FmIntegracaoHcmService;
    }

    public function getTarefasMapaOperacao()
    {
        try {
            $data = $this->FmIntegracaoHcmService->getTarefasMapaOperacao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadorMapaOperacoes(Request $request)
    {
        try {
            $data = $this->FmIntegracaoHcmService->getOperadorMapaOperacoes($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function integracaoHcm(Request $request)
    {
        try {
            $data = $this->FmIntegracaoHcmService->integracaoHcm($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
