module.exports = {
  root: true,
  env: {
    browser: true,
    es6: true,
    node: true
  },
  ignorePatterns: [
    "node_modules/",
    "**/coverage/*",
    "**/dist/*",
    "**/types/*",
    "**/__mocks__/*",
    "**/*.vue",
    "**/*.d.ts",
    "**/*.js"
  ],
  parser: "@typescript-eslint/parser",
  parserOptions: {
    project: "./tsconfig.json",
    extraFileExtensions: ['.vue']
  },
  plugins: [
    "@typescript-eslint"
  ],
  extends: [
    "airbnb-typescript/base",
    "plugin:vue/vue3-essential"
  ],
  rules: {
    'max-len': ['error', { code: 900, tabWidth: 2 }],
    'no-console': ['error', { allow: ['warn', 'error'] }],
    '@typescript-eslint/no-use-before-define': ['error', { functions: false }],
    'import/prefer-default-export': 'off',
    'no-param-reassign': ['error', { props: false }],
    'import/no-cycle': 'off',
    'class-methods-use-this': 'off',
    'import/no-unresolved': 'off',
    'linebreak-style': 0,
    '@typescript-eslint/indent': 0,
    'no-tabs': 0,
  }
};
